#include "lasp_deviceinfo.h"
#include <algorithm>
#include <cassert>

#define MAX_DEV_COUNT_PER_API 20

#if LASP_HAS_ULDAQ == 1
#include "lasp_uldaq.h"
#endif
#if LASP_HAS_RTAUDIO == 1
#include "lasp_rtaudiodaq.h"
#endif
#if LASP_HAS_PORTAUDIO == 1
#include "lasp_portaudiodaq.h"
#endif


DeviceInfoList DeviceInfo::getDeviceInfo() {
  DeviceInfoList devs;
#if LASP_HAS_ULDAQ ==1
  fillUlDaqDeviceInfo(devs);
#endif

#if LASP_HAS_RTAUDIO == 1
  fillRtAudioDeviceInfo(devs);
#endif
#if LASP_HAS_PORTAUDIO == 1
  fillPortAudioDeviceInfo(devs);
#endif

  return devs;
}

