#pragma once
#include "lasp_daq.h"

/** \addtogroup device
 * \defgroup uldaq UlDAQ specific code
 * This code is used to interface with UlDAQ compatible devices. It is only
 * tested on Linux.
 * @{
 * \addtogroup uldaq
 * @{
 */

std::unique_ptr<Daq> createUlDaqDevice(const DeviceInfo &devinfo,
                                       const DaqConfiguration &config);

/**
 * @brief Append device info list with UlDaq specific devices, if any.
 *
 * @param devinfolist Info list to append to.
 */
void fillUlDaqDeviceInfo(DeviceInfoList& devinfolist);

/** @} */
/** @} */
