#pragma once
#include "lasp_daq.h"
#include <memory>

/** \addtogroup device
 * @{
 * \defgroup portaudio PortAudio backend
 * This code is used to interface with the PortAudio cross-platform audio
 * interface.
 *
 * \addtogroup portaudio
 * @{
 */


/**
 * @brief Method called from Daq::createDaq.
 *
 * @param devinfo Device info
 * @param config DAQ Configuration settings
 *
 * @return Pointer to Daq instance. Throws Runtime errors on error.
 */
std::unique_ptr<Daq> createPortAudioDevice(const DeviceInfo& devinfo,
        const DaqConfiguration& config);

/**
 * @brief Append PortAudio backend devices to the list
 *
 * @param devinfolist List to append to
 */
void fillPortAudioDeviceInfo(DeviceInfoList &devinfolist);

/** @} */
/** @} */
