#!/bin/sh
# Build LASP on Arch Linux, assuming we start in a clean docker container.
# After that, test stuff.
# Assumptions
# - CWD is root of lasp repository
# - Nothing is installed

# Stop on first error
set -e
# Update cache
apt update
# Install requirements
apt install -y git python3.10-venv libopenblas-dev python3-pip libfftw3-dev libusb-1.0-0-dev libpulse-dev python3-build
# Build
git submodule update --init --recursive
python3 -m build
python3 -m venv .venv
source .venv/bin/activate
pip install pytest
pip install dist/lasp-*linux_x86_64.whl
# Test
pytest
